{ #######################################################
           Demoprogramm fr SwissDelphiCenter.ch
            ( http://www.SwissDelphiCenter.ch )

  Special thanks to Jailbird, who developed a big part of
  this Code.

  #######################################################
  ###################### FREEWARE #######################
  #######################################################
}

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Gauges, StdCtrls, vfw;

type
  TMainForm = class(TForm)
    Gauge1: TGauge;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Edit2: TEdit;
    Button4: TButton;
    label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button5: TButton;
    function ExtractAVISound(InputFile, Outputfile: PChar): Boolean;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;
  abort: Boolean;

implementation

{$R *.DFM}

{Die 'SaveCallback' Funktion erlaubt es dem Benutzer den
 aktuellen Prozess Status zu erfahren und den Speichervorgang
 vorzeitig abzubrechen. Diese Funktion muss NICHT vom Benutzer
 aufgerufen werden.

 The 'SaveCallback' function allows the user to get the
 process status and abort the save progress. This function
 needn't to call by the user.}

function SaveCallback(nPercent: Int): Bool; pascal;
begin
  Application.ProcessMessages;

  MainForm.Gauge1.progress := nPercent; //Speicher Status in Prozent
  //Save Status in Percent
  if abort = True then
    Result := True          //Wenn die Funktion "True" zurckgibt, wird der Speichervorgang fortgesetzt.
  else                     //If then function returns "True", the Process will continue
    Result := False;       //Gibt sie "False" zurck wird der Vorgang abgebrochen
end;                       //If it returns "False" the process will abort


{Die folgende Funktion erwartet zwei Parameter:

 Inputfile: PChar
  Geben Sie hier die die AVI Datei an aus welche Sie
  die Audiospur extrahieren mchten.

 Outputfile: PChar
  Geben Sie einen Pfad + Dateinamen einer WAVE Datei an.
  In diese Datei wird die AudioSpur gespeichert.

  HINWEIS:
  Geben Sie nur eine WAVE Datei als Ausgabedatei an wenn
  die Audiodaten in der AVI Datei unkomprimiert (als PCM WAVE)
  vorliegen.

 ####################################################

 The following function needs two parameters:

 InputFile: PChar
  Enter a Dir + Filename of a AVI File.

 OutputFile: PChar
  Enter a Dir + Filename of a WAVE File where do you want to
  put the audiodata of the movie.

  TIP:
  Enter jus a Filename of a WAVE File if the audiodata of the
  movie is in uncompressed PCM Format.

 ###########################################################

 WICHTIG:
  Stellen Sie vor dem aufrufen der Funktion 'ExtractAVISound' sicher
  das die Eingabedatei (Inputfile) ber eine AudioSpur verfgt.

 IMPORTANT:
  Before calling the 'ExtractAVISound' function be sure that the
  Inputfile has a audiotrace.
 }

function TMainForm.ExtractAVISound(InputFile, Outputfile: PChar): Boolean;
var
  PFile: IAviFile;
  PAvi: IAviStream;
  plpOptions: PAviCompressOptions;
begin
  Abort := False;

  if Fileexists(StrPas(Outputfile)) then 
  begin
    case MessageDlg('Ausgabedatei existiert bereits. berschreiben?',
      mtWarning, [mbYes, mbNo], 0) of
      mrYes: 
        begin
          DeleteFile(StrPas(Outputfile));  //Wichtig, da die Funktion sonst nur so viel der
        end;                             //Datei berschreibt wie gebraucht wird.
      //Important because the function overwrite just
      //the part of the file which is needed.
      mrNo: 
        begin
          Exit;
        end;
    end;
  end;

  Button1.Enabled := False;
  Button5.Enabled := True;

  try            //Initialisiert die API
    AviFileInit;  //Init the API
    if AviFileOpen(PFile, Inputfile, 0, nil) <> 0 then  //ffnet eine AVI Datei
    begin                                               //Opens a AVI File
      MessageDlg('Fehler beim laden des Videos. Mglicherweise wird die Datei von einem anderen Prozess verwendet.'
        + #13#10 +
        'Schlieen Sie alle in Frage kommenden Anwendungen und versuchen Sie es erneut.',
        mtError, [mbOK], 0);
      Result := False;
      Exit;
    end;
    if AviFileGetStream(PFile, PAvi, StreamTypeAudio, 0) <> 0 then
    begin
      MessageDlg(
        'Fehler beim laden des AudioStreams. Bitte berprfen Sie, ob dieses Video ber einen AudioStream verfgt.',
        mtError, [mbOK], 0);
      AviFileExit;
      Result := False;
      Exit;
    end;

    //Speichert den AudioStream
    //Saves the AudioStream
    if AviSaveV(Outputfile, nil, @SaveCallback, 1, PAvi, plpOptions) <> 0 then
    begin
      MessageDlg('Fehler beim speichern des AudioStreams oder Sie haben den Speichervorgang abgebrochen.',
        mtError, [mbOK], 0);
      AviStreamRelease(PAvi);
      AviFileExit;
      Result := False;
      Exit;
    end;
  finally
    AviStreamRelease(PAvi);
    AviFileExit;
  end;
  Result := True;  //'TRUE' zurckgeben wenn alles geklappt hat
  //return 'TRUE' if all right
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  Application.terminate;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    Edit1.Text := OpenDialog1.FileName;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    Edit2.Text := SaveDialog1.FileName;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if (Edit1.Text <> '') and (Edit2.Text <> '') then 
  begin
    if ExtractAVISound(PChar(Edit1.Text), PChar(Edit2.Text)) then
      ShowMessage('Export erfolgreich!')
    else
      ShowMessage('Fehler beim Exportieren');
  end;

  Button1.Enabled := True;
  Button5.Enabled := False;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  abort := True;
end;

end.
